﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=4.2
@EndOfDesignText@

Sub Process_Globals
	Private sql As SQL
End Sub

Public Sub Init

	Dim user As String = "user"
	Dim PW As String =  "password"
	Dim myDB As String = "keystore"
	Dim serverPort As String = "url:3306"
	
	sql.Initialize("com.mysql.jdbc.Driver",  _
			 $"jdbc:mysql://${serverPort}/${myDB}?"$ & _
			 $"user=${user}&password=${PW}"$)
	
	CreateDatabase
End Sub

Private Sub CreateDatabase
		
	Log("This needs to be done by hand using your favorite MySQL workbench")

	'--- Create a database named keystore
	'--- create a table named data
	
	'CREATE TABLE `data` (`user` varchar(254) Not Null, `the_key` varchar(254) Not Null, `value` blob, `id` int(11) DEFAULT Null, `the_time` bigint(20) DEFAULT Null, UNIQUE KEY `pri_index` (`user`,`the_key`), KEY `id_index` (`id`) ) ENGINE=InnoDB DEFAULT CHARSET=latin1;
		

End Sub

Public Sub AddItem(item As Item)
	Try
		Dim id As Long
		Dim lastId As String = sql.ExecQuerySingleResult2("SELECT max(id) FROM data WHERE user = ?", Array(item.UserField))
		If lastId = Null Then
			 id = 0
		Else
			id = lastId + 1
		End If

		If item.TimeField < DateTime.Now - 3 * DateTime.TicksPerMinute Then
			Log("checking old record")
			'--- this is an old record. Maybe there is a newer one...
			Dim rs As ResultSet = sql.ExecQuery2("SELECT `the_time`, `value` FROM data WHERE 'user' = ? AND 'the_key' = ?", Array(item.UserField, item.KeyField))
			If rs.NextRow Then
				Dim currentTime As Long = rs.GetLong("'the_time'")
				If currentTime > item.TimeField Then
					Log("Old record discarded.")
					item.ValueField = rs.GetBlob("value")
					item.TimeField = currentTime
				End If
			End If
			rs.Close
		End If
		
		'--- mysql kill the old, insert the new
		Dim s1 As String = $"DELETE FROM data WHERE  `the_key` = "${item.KeyField}" and `user` = "${item.UserField}""$
		sql.ExecNonQuery(s1)
		
'		Log("******************************************************")
'		Log("Items time field: " & item.TimeField)
'		Log("Date time now: " & DateTime.now)
'		Dim ll As Long = Min(item.TimeField, DateTime.Now)
'		Log("Get the min value: " & ll)
'		Log("******************************************************")

		Dim MinTime As Long = MyMin(item.TimeField, DateTime.Now)
		Dim s3 As String = "INSERT INTO data (`user`, `the_key`, `value`, `id`,`the_time`) VALUES (?,?,?,?,?)"
		sql.ExecNonQuery2(s3, Array As Object(item.UserField,item.KeyField,item.ValueField,id,MinTime))
		
	Catch
		Log("AddItem: " & LastException)
	End Try
End Sub

private Sub MyMin(t1 As Long, t2 As Long) As Long
	'--- b4j returns a double, not good for mysql
	Dim retMe As Long = Min(t1,t2)
	Return retMe
End Sub



Public Sub GetUserItems (user As String, lastId As Int) As List
	Dim subName As String = "GetUserItems"
	Dim items As List
	items.Initialize
	Try
		Dim rs As ResultSet = sql.ExecQuery2("SELECT * FROM data WHERE user = ? AND id > ?", Array(user, lastId))
		Do While rs.NextRow
			Dim item As Item
			item.Initialize
			item.UserField = user
			item.KeyField = rs.GetString("the_key")
			item.ValueField = rs.GetBlob("value")
			item.idField = rs.GetLong("id")
			item.TimeField = rs.GetLong("the_time")
			items.Add(item)
		Loop
		rs.Close
	Catch
		Log($"${subName}:  ${LastException}"$)
	End Try
	Return items
End Sub


Public Sub DeleteUser(user As String)
	Dim subName As String = "DeleteUser"
	Try
		sql.ExecNonQuery2("DELETE FROM data WHERE 'user' = ?", Array(user))
	Catch
		Log($"${subName}:  ${LastException}"$)
	End Try
End Sub

